DEFINT A-Z

' This is a test of the procedures in MOUSELIB.ASM.
' The combined library QBMOUSE.QLB must be loaded
' when the programming environment is started.

' $INCLUDE: 'MOUSELIB.BI'

SCREEN 13

r = MouseInit(VARSEG(mouse), VARPTR(mouse))
IF r = 0 THEN
    PRINT "MouseInit failed, press any key to exit..."
    DO
    LOOP UNTIL INKEY$ <> ""
    END
END IF

MouseSetPosition 160, 100
MouseSetCrossCursor
MouseShow
PRINT "Press any key to hide mouse cursor..."
DO
LOOP UNTIL INKEY$ <> ""
MouseHide
PRINT "Press any key to show mouse cursor..."
DO
LOOP UNTIL INKEY$ <> ""
CLS
PRINT "Press any key to exit from loop..."
MouseShow
DO
    LOCATE 2, 1
    PRINT mouse.x; "    "
    PRINT mouse.y; "    "
    PRINT mouse.left; "    "
    PRINT mouse.right; "    "
    IF mouse.event AND POSITION THEN PRINT "POSITION ";
    IF mouse.event AND LPRESS THEN PRINT "LPRESS ";
    IF mouse.event AND LRELEASE THEN PRINT "LRELEASE ";
    IF mouse.event AND RPRESS THEN PRINT "RPRESS ";
    IF mouse.event AND RRELEASE THEN PRINT "RRELEASE ";
    spaceCount = 40 - POS(0)
    PRINT SPACE$(spaceCount)
LOOP UNTIL INKEY$ <> ""

' This code allows you to determine the approximate
' rate at which the mouse generates interrupts.
'
' To get an idea of just how slow humans are, try
' generating the interrupts by pressing and releasing
' the mouse buttons instead of moving the mouse.

CLS
PRINT "Begin moving the mouse continuously..."
mouse.event = 0
DO
LOOP UNTIL mouse.event
s! = TIMER
DO
    IF mouse.event THEN
        cnt = cnt + 1
        mouse.event = 0
    END IF
    f! = TIMER
    IF f! > s! + 4 THEN EXIT DO
LOOP
PRINT "OK"
PRINT "The interrupt rate is approximately:"
PRINT cnt \ (f! - s!); "interrupts per second"
PRINT
PRINT "Press any key to continue..."
DO
LOOP UNTIL INKEY$ <> ""

PRINT
PRINT "InterruptSubClocks ="; InterruptSubClocks
PRINT "Press any key to exit..."
DO
LOOP UNTIL INKEY$ <> ""

